/* *******************************************************************
   Functions used for time and NTP
   ***************************************************************** */
   
#pragma once

void showTime() {
  static int previousSec = 0;
  time_t now;                       // this are the seconds since Epoch (1970) - UTC
  tm tm;                            // the structure tm holds time information in a more convenient way
  time(&now);                       // read the current time
  localtime_r(&now, &tm);           // update the structure tm with the current time
  if (previousSec != tm.tm_sec) {
    previousSec = tm.tm_sec;
    char buffer[42] {0};              // a buffer large enough to hold your output
    strftime (buffer, sizeof(buffer), "%Y-%m-%d %H:%M:%S", &tm);  // for different formats see https://cplusplus.com/reference/ctime/strftime/
    Serial.println(buffer);
  }
}

void ntpConfigTime(String tzshort, String ntpServer) {
  char ntpServerCA[42];
  char tzshortCA[42];
  ntpServer.toCharArray(ntpServerCA, sizeof(ntpServerCA));
  tzshort.toCharArray(tzshortCA, sizeof(tzshortCA));
  Serial.print(F("ntpServerCA=")); Serial.println(ntpServerCA);
  Serial.print(F("tzshortCA="));   Serial.println(tzshortCA);
#ifdef ARDUINO_ARCH_ESP32             // for the ESP32 (needs 3 lines)
  configTime(0, 0, ntpServerCA);      // 0, 0 because we will use TZ in the next line
  setenv("TZ", tzshortCA, 1);         // Set environment variable with your time zone
  tzset();
#endif
#ifdef ARDUINO_ARCH_ESP8266           // for the ESP8266
  configTime(tzshortCA, ntpServerCA); // the ESP8266 you only need this IMPORTANT ONE LINER in your sketch!
#endif
}
